=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class RatesAtCheckoutApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Generate a live rates request
    # Initiates a live rates request. Include either the object ID for an existing Address record or a fully formed Address object when entering an address value. You can also enter the object ID of an existing User Parcel Template or a fully formed User Parcel Template object as the parcel value.
    # @param [Hash] opts the optional parameters
    # @option opts [CreateLiveRateRequest] :body Generate rates at checkout
    # @return [CreateLiveRateResponse]
    def rates_at_checkout_create(opts = {})
      data, _status_code, _headers = rates_at_checkout_create_with_http_info(opts)
      data
    end

    # Generate a live rates request
    # Initiates a live rates request. Include either the object ID for an existing Address record or a fully formed Address object when entering an address value. You can also enter the object ID of an existing User Parcel Template or a fully formed User Parcel Template object as the parcel value.
    # @param [Hash] opts the optional parameters
    # @option opts [CreateLiveRateRequest] :body Generate rates at checkout
    # @return [Array<(CreateLiveRateResponse, Integer, Hash)>] CreateLiveRateResponse data, response status code and response headers
    def rates_at_checkout_create_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesAtCheckoutApi.rates_at_checkout_create ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/live-rates'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'CreateLiveRateResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesAtCheckoutApi#rates_at_checkout_create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Clear current default parcel template
    # Clear the currently configured default parcel template for live rates.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def rates_at_checkout_default_parcel_delete(opts = {})
      rates_at_checkout_default_parcel_delete_with_http_info(opts)
      nil
    end

    # Clear current default parcel template
    # Clear the currently configured default parcel template for live rates.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def rates_at_checkout_default_parcel_delete_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesAtCheckoutApi.rates_at_checkout_default_parcel_delete ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/live-rates/settings/parcel-template'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesAtCheckoutApi#rates_at_checkout_default_parcel_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Show current default parcel template
    # Retrieve and display the currently configured default parcel template for live rates.
    # @param [Hash] opts the optional parameters
    # @return [GetLiveRateResponse]
    def rates_at_checkout_default_parcel_list(opts = {})
      data, _status_code, _headers = rates_at_checkout_default_parcel_list_with_http_info(opts)
      data
    end

    # Show current default parcel template
    # Retrieve and display the currently configured default parcel template for live rates.
    # @param [Hash] opts the optional parameters
    # @return [Array<(GetLiveRateResponse, Integer, Hash)>] GetLiveRateResponse data, response status code and response headers
    def rates_at_checkout_default_parcel_list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesAtCheckoutApi.rates_at_checkout_default_parcel_list ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/live-rates/settings/parcel-template'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'GetLiveRateResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesAtCheckoutApi#rates_at_checkout_default_parcel_list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update default parcel template
    # Update the currently configured default parcel template for live rates. The object_id in the request payload should identify the user parcel template to be the new default.
    # @param [Hash] opts the optional parameters
    # @option opts [DefaultParcelTemplate] :body Generate rates at checkout
    # @return [GetLiveRateResponse]
    def rates_at_checkout_default_parcel_update(opts = {})
      data, _status_code, _headers = rates_at_checkout_default_parcel_update_with_http_info(opts)
      data
    end

    # Update default parcel template
    # Update the currently configured default parcel template for live rates. The object_id in the request payload should identify the user parcel template to be the new default.
    # @param [Hash] opts the optional parameters
    # @option opts [DefaultParcelTemplate] :body Generate rates at checkout
    # @return [Array<(GetLiveRateResponse, Integer, Hash)>] GetLiveRateResponse data, response status code and response headers
    def rates_at_checkout_default_parcel_update_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RatesAtCheckoutApi.rates_at_checkout_default_parcel_update ...'
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/live-rates/settings/parcel-template'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'GetLiveRateResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RatesAtCheckoutApi#rates_at_checkout_default_parcel_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
